OrderPreservingPartitioner (apache-cassandra API)
Date: 2018-02-12

org.apache.cassandra.dht

## Class OrderPreservingPartitioner

- java.lang.Object
- - org.apache.cassandra.dht.OrderPreservingPartitioner

- All Implemented Interfaces:
    IPartitioner

      public class OrderPreservingPartitioner
      extends java.lang.Object
      implements IPartitioner

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `OrderPreservingPartitioner.StringToken`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.math.BigInteger` | `CHAR_MASK`
    `static OrderPreservingPartitioner` | `instance`
    `static OrderPreservingPartitioner.StringToken` | `MINIMUM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OrderPreservingPartitioner()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `DecoratedKey` | `decorateKey(java.nio.ByteBuffer key)` Transform key to object representation of the on-disk format.
    `java.util.Map<Token,java.lang.Float>` | `describeOwnership(java.util.List<Token> sortedTokens)` Calculate the deltas between tokens in the ring in order to compare relative sizes.
    `OrderPreservingPartitioner.StringToken` | `getMinimumToken()`
    `OrderPreservingPartitioner.StringToken` | `getRandomToken()`
    `OrderPreservingPartitioner.StringToken` | `getToken(java.nio.ByteBuffer key)`
    `Token.TokenFactory` | `getTokenFactory()`
    `AbstractType<?>` | `getTokenValidator()`
    `OrderPreservingPartitioner.StringToken` | `midpoint(Token ltoken, Token rtoken)` Calculate a Token representing the approximate "middle" of the given range.
    `boolean` | `preservesOrder()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MINIMUM

          public static final OrderPreservingPartitioner.StringToken MINIMUM

    - #### CHAR_MASK

          public static final java.math.BigInteger CHAR_MASK

    - #### instance

          public static final OrderPreservingPartitioner instance

  - ### Constructor Detail

    - #### OrderPreservingPartitioner

          public OrderPreservingPartitioner()

  - ### Method Detail

    - #### decorateKey

          public DecoratedKey decorateKey(java.nio.ByteBuffer key)

      Description copied from interface: `IPartitioner`
      Transform key to object representation of the on-disk format.
      Specified by:
        `decorateKey` in interface `IPartitioner`
      Parameters:
        `key` - the raw, client-facing key
      Returns:
        decorated version of key

    - #### midpoint

          public OrderPreservingPartitioner.StringToken midpoint(Token ltoken,
                                                                 Token rtoken)

      Description copied from interface: `IPartitioner`
      Calculate a Token representing the approximate "middle" of the given range.
      Specified by:
        `midpoint` in interface `IPartitioner`
      Returns:
        The approximate midpoint between left and right.

    - #### getMinimumToken

          public OrderPreservingPartitioner.StringToken getMinimumToken()

      Specified by:
        `getMinimumToken` in interface `IPartitioner`
      Returns:
        A Token smaller than all others in the range that is being partitioned. Not legal to assign to a node or key. (But legal to use in range scans.)

    - #### getRandomToken

          public OrderPreservingPartitioner.StringToken getRandomToken()

      Specified by:
        `getRandomToken` in interface `IPartitioner`
      Returns:
        a randomly generated token

    - #### getTokenFactory

          public Token.TokenFactory getTokenFactory()

      Specified by:
        `getTokenFactory` in interface `IPartitioner`

    - #### preservesOrder

          public boolean preservesOrder()

      Specified by:
        `preservesOrder` in interface `IPartitioner`
      Returns:
        True if the implementing class preserves key order in the Tokens it generates.

    - #### getToken

          public OrderPreservingPartitioner.StringToken getToken(java.nio.ByteBuffer key)

      Specified by:
        `getToken` in interface `IPartitioner`
      Returns:
        a Token that can be used to route a given key (This is NOT a method to create a Token from its string representation; for that, use TokenFactory.fromString.)

    - #### describeOwnership

          public java.util.Map<Token,java.lang.Float> describeOwnership(java.util.List<Token> sortedTokens)

      Description copied from interface: `IPartitioner`
      Calculate the deltas between tokens in the ring in order to compare relative sizes.
      Specified by:
        `describeOwnership` in interface `IPartitioner`
      Parameters:
        `sortedTokens` - a sorted List of Tokens
      Returns:
        the mapping from 'token' to 'percentage of the ring owned by that token'.

    - #### getTokenValidator

          public AbstractType<?> getTokenValidator()

      Specified by:
        `getTokenValidator` in interface `IPartitioner`

Copyright © 2018 The Apache Software Foundation